String dump := method(
//  write("String\n")
  "\"" .. self .. "\""
)

Number dump := method(
//  write("Number\n")
  asString
)

List dump := method(
//  write("List\n")
  "List clone" .. String join(clone map(i, v, " add(" .. v dump .. ")"))
)

Map dump := method(
//  write("Map\n")
  ret := "Map clone"
  self foreach(i, v,
    ret = ret append(" atPut(" .. i dump .. ", " .. v dump .. ")")
  )
  ret
)

Nil dump := method(
  "Nil"
)

Object dump := method(
//  write("Object\n")
  ret := self type .. " clone do(\n"
  self slotNames foreach(i, sn,
//    write(sn, "\n")
    if(sn != "proto",
      slot := self getSlot(sn)
      if (slot hasProto(Block) == Nil and(slot hasProto(CFunction) == Nil),
        ret = ret append(sn .. " := " .. slot dump .. "\n")
      )
    )
  )
  ret = ret append(")\n")
  ret
)

Serialize := Object clone do(
  dump := method(o, fname,
    of := File clone setPath(fname)
    of writeTransaction(
      of write(o dump(o), "\n")
      # now we have no truncating...
      of write("             ")
    )
  )
)


